import { IConfiguration, ObjectIdentifier } from '../interfaces';
export declare class BaseConfiguration implements IConfiguration {
    get size(): number;
    keys(): ObjectIdentifier[];
    get(key: ObjectIdentifier, ...args: any[]): any;
    dup(key: ObjectIdentifier): any;
    has(key: ObjectIdentifier): boolean;
    set(key: ObjectIdentifier, value: any): any;
    putAll(props: IConfiguration): void;
    stringPropertyNames(): ObjectIdentifier[];
    getProperty(key: ObjectIdentifier, defaultValue?: any): any;
    addProperty(key: ObjectIdentifier, value: any): void;
    setProperty(key: ObjectIdentifier, value: any): any;
    clear(): void;
    toJSON(): object;
    clone(): IConfiguration;
}
export declare class BasicConfiguration extends BaseConfiguration {
    private innerConfig;
    get size(): number;
    keys(): ObjectIdentifier[];
    get(key: ObjectIdentifier, ...args: any[]): any;
    dup(key: ObjectIdentifier): any;
    has(key: ObjectIdentifier): boolean;
    set(key: ObjectIdentifier, value: any): any;
    putAll(props: IConfiguration): void;
    clear(): void;
    toJSON(): object;
}
export declare class ObjectConfiguration extends BaseConfiguration {
    private innerConfig;
    get size(): number;
    keys(): ObjectIdentifier[];
    get(key: ObjectIdentifier, ...args: any[]): any;
    dup(key: ObjectIdentifier): any;
    has(key: ObjectIdentifier): boolean;
    set(key: ObjectIdentifier, value: any): any;
    putAll(props: IConfiguration): void;
    putObject(props: object, needClone?: boolean): void;
    clear(): void;
    toJSON(): object;
    clone(): IConfiguration;
}
