import 'reflect-metadata';
import { IContainer, ObjectDefinitionOptions, ObjectIdentifier } from '../interfaces';
import { ObjectDefinition } from '..';
import { XmlApplicationContext } from './xml/xmlApplicationContext';
export declare class Container extends XmlApplicationContext implements IContainer {
    id: string;
    bind<T>(target: T, options?: ObjectDefinitionOptions): void;
    bind<T>(identifier: ObjectIdentifier, target: T, options?: ObjectDefinitionOptions): void;
    registerCustomBinding(objectDefinition: ObjectDefinition, target: any): void;
    private convertOptionsToDefinition;
    createChild(baseDir?: string): IContainer;
    resolve<T>(target: T): T;
    get<T>(identifier: any, args?: any): T;
    getAsync<T>(identifier: any, args?: any): Promise<T>;
    protected getIdentifier(target: any): any;
}
