/**
 * xml解析工具函数集合
 */
export declare function nodeAttr(ele: Element, name: string): string;
export declare function nodeText(ele: Element): string;
export declare function nodeHasAttr(ele: Element, name: string): boolean;
export declare function nodeNameEq(ele: Element, desiredName: string): boolean;
export declare function nodeName(ele: Element): string;
export declare type callback = (node: Element) => Promise<void>;
export declare type callbackSync = (node: Element) => void;
/**
 * 异步遍历element子节点
 * @param ele xml element节点
 * @param callback async function
 */
export declare function eachSubElement(ele: Element, callback: any): Promise<void>;
/**
 * 同步遍历element子节点
 * @param ele xml element节点
 * @param callbackSync function
 */
export declare function eachSubElementSync(ele: Element, callbackSync: any): void;
/**
 * 获取第一个element类型子节点
 * @param ele xml element节点
 */
export declare function firstSubElement(ele: Element): Element;
/**
 * 获取第一个cdata类型子节点
 * @param ele xml element节点
 */
export declare function firstCDATAText(ele: Element): string;
